chiark / gitweb /
dgit: sbuild: Fix typo which broke dgit sbuild
[dgit.git] / tests / lib
index 0b0ae47280f0158efd3471ccf869d25afe6c1414..fbe04b7d8d91a9c63728411a4f1431dfccf70261 100644 (file)
--- a/tests/lib
+++ b/tests/lib
@@ -34,6 +34,8 @@ mkdir -p $tmp/gnupg
 cp $troot/gnupg/* $tmp/gnupg
 chmod go-rw $tmp/gnupg/*
 
+export DEBCHANGE_VENDOR=dpkg
+
 mkdir -p $tmp/incoming
 cat <<END >$tmp/dput.cf
 [test-dummy]
@@ -139,10 +141,14 @@ t-git-none () {
        (set -e; cd $tmp/git; tar xf $troot/git-template.tar)
 }
 
+t-git-merge-base () {
+       git merge-base $1 $2 || test $? = 1
+}
+
 t-has-ancestor () {
        local now=`git rev-parse HEAD`
        local ancestor=`git rev-parse $1^{}`
-       local mbase=`git merge-base $ancestor $now`
+       local mbase=`t-git-merge-base $ancestor $now`
        if [ x$mbase != x$ancestor ]; then
                fail "not ff $ancestor..$now, $mbase != $ancestor"
        fi
@@ -155,7 +161,7 @@ t-prep-newpackage () {
        t-git-none
        t-worktree $v
        cd $p
-       if ! git-show-ref --verify --quiet refs/heads/master; then
+       if ! git show-ref --verify --quiet refs/heads/master; then
                git branch -m dgit/sid master
                git remote rm dgit
        fi
@@ -268,6 +274,7 @@ t-rm-dput-dropping () {
 
 t-dgit () {
        local dgit=${DGIT_TEST-dgit}
+       pwd
        : '
 {{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{{'
        $dgit --dgit=$dgit --dget:-u --dput:--config=$tmp/dput.cf \
@@ -324,6 +331,12 @@ t-git-get-ref () {
        '
 }
 
+t-ref-same-exact () {
+       local name="$1"
+       local val=`t-git-get-ref-exact $name`
+       t-ref-same-val "$name" $val
+}
+
 t-ref-same () {
        local name="$1"
        local val=`t-git-get-ref $name`
@@ -360,7 +373,7 @@ t-refs-same () {
 t-refs-notexist () {
        local val
        for g in $*; do
-               val=`t-git-get-ref $g >$tmp/t.refx`
+               val=`t-git-get-ref $g`
                if [ "x$val" != x ]; then
                        fail "ref $g unexpectedly exists ($val)"
                fi
@@ -368,7 +381,16 @@ t-refs-notexist () {
 }
 
 t-v-tag () {
-       echo refs/tags/debian/${v//\~/_}
+       echo refs/tags/test-dummy/${v//\~/_}
+}
+
+t-check-pushed-master () {
+       local master=`t-git-get-ref refs/heads/master`
+       if [ x$master = x$t_ref_val ]; then return; fi
+       if [ x$master = x ]; then fail "failed to push master"; fi
+       # didn't update master, it must be not FF
+       local mbase=`t-git-merge-base $master $t_ref_val`
+       if [ x$mbase = x$master ]; then fail "failed to ff master"; fi
 }
 
 t-pushed-good () {
@@ -385,6 +407,7 @@ t-pushed-good () {
         t-refs-same \
                refs/dgit/sid \
                `t-v-tag`
+        ${t_check_pushed_master:- : NOT-DRS-NO-CHECK-PUSHED-MASTER}
         t-refs-notexist \
                refs/dgit/unstable
        )
@@ -433,15 +456,6 @@ t-tstunt-parsechangelog () {
        t-tstunt dpkg-parsechangelog Dpkg/Changelog/Parse.pm
 }
 
-t-prep-mergechangelogs () {
-       local b=merge.dpkg-mergechangelogs
-       git config $b.name 'debian/changelog merge driver'
-       git config $b.driver 'dpkg-mergechangelogs -m %O %A %B %A'
-       mkdir -p .git/info
-       echo >>.git/info/attributes \
-               'debian/changelog merge=dpkg-mergechangelogs'
-}
-
 t-ref-dsc-dgit () {
        local dsc=${p}_${v}.dsc
        local val=`t-822-field $tmp/incoming/$dsc Dgit`
@@ -459,11 +473,11 @@ t-apply-diff () {
 
 t-commit () {
        local msg=$1
-       v=1.$revision
+       v=${2-1.$revision}
        dch -v$v --distribution unstable "$1"
        git add debian/changelog
        debcommit
-       revision=$(( $revision + 1 ))
+       revision=$(( ${revision-0} + 1 ))
 }
 
 t-git-config () {
@@ -475,14 +489,21 @@ t-drs () {
  t-git-config dgit-distro.test-dummy.git-url "ext::$troot/drs-git-ext %S "
  t-git-config dgit-distro.test-dummy.git-check true
  t-git-config dgit-distro.test-dummy.git-create true
-       cp $root/tests/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
-       cp $root/tests/suites $tmp/.
+       cp $troot/gnupg/{dd.gpg,dm.gpg,dm.txt} $tmp/.
+       cp $troot/suites $tmp/.
+       cp $troot/suites $tmp/suites-master
+
+       export t_check_pushed_master=t-check-pushed-master
 
        drs_dispatch=$tmp/distro=test-dummy
        mkdir $drs_dispatch
-       ln -sf $root $drs_dispatch/dgit-live
+
+       if [ "x$DGIT_TEST_INTREE" != x ]; then
+               ln -sf "$DGIT_TEST_INTREE" $drs_dispatch/dgit-live
+       fi
+
        ln -sf $tmp/git $drs_dispatch/repos
-       ln -sf $tmp/suites $tmp/dm.txt $drs_dispatch/
+       ln -sf $tmp/suites $tmp/suites-master $tmp/dm.txt $drs_dispatch/
        mkdir -p $drs_dispatch/keyrings
        ln -sf $tmp/dd.gpg $drs_dispatch/keyrings/debian-keyring.gpg
        ln -sf $tmp/dm.gpg $drs_dispatch/keyrings/debian-maintainers.gpg
@@ -510,10 +531,18 @@ t-policy-admin () {
        ${DGIT_INFRA_PFX}dgit-repos-admin-debian --repos $tmp/git "$@"
 }
 
+t-policy-nonexist () {
+       ln -sf no-such-file-or-directory $drs_dispatch/policy-hook
+}
+
 t-policy () {
        local policyhook=$1
-       ln -sf ${DGIT_INFRA_PFX}$policyhook \
-               $drs_dispatch/policy-hook
+       policyhook=${DGIT_INFRA_PFX}$policyhook
+       case $policyhook in
+       */*)    ;;
+       *)      policyhook=`type -P $policyhook` ;;
+       esac
+       ln -sf "$policyhook" $drs_dispatch/policy-hook
 }
 
 t-debpolicy () {